Index: uspace/srv/hid/fb/port/kchar.c
===================================================================
--- uspace/srv/hid/fb/port/kchar.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/hid/fb/port/kchar.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -83,10 +83,7 @@
 		return rc;
 	
-	kchar.addr = as_get_mappable_page(1);
-	if (kchar.addr == NULL)
-		return ENOMEM;
-	
-	rc = physmem_map((void *) paddr, kchar.addr,
-	    ALIGN_UP(1, PAGE_SIZE) >> PAGE_WIDTH, AS_AREA_READ | AS_AREA_WRITE);
+	rc = physmem_map((void *) paddr,
+	    ALIGN_UP(1, PAGE_SIZE) >> PAGE_WIDTH,
+	    AS_AREA_READ | AS_AREA_WRITE, (void *) &kchar.addr);
 	if (rc != EOK)
 		return rc;
Index: uspace/srv/hid/fb/port/kfb.c
===================================================================
--- uspace/srv/hid/fb/port/kfb.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/hid/fb/port/kfb.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -756,12 +756,8 @@
 	
 	kfb.size = scanline * height;
-	kfb.addr = as_get_mappable_page(kfb.size);
-	if (kfb.addr == NULL) {
-		free(kfb.glyphs);
-		return ENOMEM;
-	}
-	
-	rc = physmem_map((void *) paddr + offset, kfb.addr,
-	    ALIGN_UP(kfb.size, PAGE_SIZE) >> PAGE_WIDTH, AS_AREA_READ | AS_AREA_WRITE);
+	
+	rc = physmem_map((void *) paddr + offset,
+	    ALIGN_UP(kfb.size, PAGE_SIZE) >> PAGE_WIDTH,
+	    AS_AREA_READ | AS_AREA_WRITE, (void *) &kfb.addr);
 	if (rc != EOK) {
 		free(kfb.glyphs);
Index: uspace/srv/hid/fb/port/niagara.c
===================================================================
--- uspace/srv/hid/fb/port/niagara.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/hid/fb/port/niagara.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -103,11 +103,6 @@
 		return rc;
 	
-	niagara.fifo =
-	    (output_fifo_t *) as_get_mappable_page(sizeof(output_fifo_t));
-	if (niagara.fifo == NULL)
-		return ENOMEM;
-	
-	rc = physmem_map((void *) paddr, (void *) niagara.fifo, 1,
-	    AS_AREA_READ | AS_AREA_WRITE);
+	rc = physmem_map((void *) paddr, 1,
+	    AS_AREA_READ | AS_AREA_WRITE, (void *) &niagara.fifo);
 	if (rc != EOK)
 		return rc;
Index: uspace/srv/hid/input/Makefile
===================================================================
--- uspace/srv/hid/input/Makefile	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/hid/input/Makefile	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -43,5 +43,4 @@
 	port/adb_mouse.c \
 	port/chardev.c \
-	port/chardev_mouse.c \
 	port/gxemul.c \
 	port/msim.c \
@@ -52,5 +51,4 @@
 	proto/adb.c \
 	proto/mousedev.c \
-	proto/ps2.c \
 	ctl/apple.c \
 	ctl/gxe_fb.c \
Index: uspace/srv/hid/input/generic/input.c
===================================================================
--- uspace/srv/hid/input/generic/input.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/hid/input/generic/input.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -39,4 +39,5 @@
 #include <adt/list.h>
 #include <bool.h>
+#include <fibril_synch.h>
 #include <ipc/services.h>
 #include <ipc/input.h>
@@ -83,4 +84,6 @@
 async_sess_t *irc_sess = NULL;
 
+static FIBRIL_MUTEX_INITIALIZE(discovery_lock);
+
 void kbd_push_data(kbd_dev_t *kdev, sysarg_t data)
 {
@@ -172,8 +175,17 @@
 
 /** Mouse pointer has moved. */
-void mouse_push_event_move(mouse_dev_t *mdev, int dx, int dy)
+void mouse_push_event_move(mouse_dev_t *mdev, int dx, int dy, int dz)
 {
 	async_exch_t *exch = async_exchange_begin(client_sess);
-	async_msg_2(exch, INPUT_EVENT_MOVE, dx, dy);
+	if (dx || dy)
+		async_msg_2(exch, INPUT_EVENT_MOVE, dx, dy);
+	if (dz) {
+		// TODO: Implement proper wheel support
+		keycode_t code = dz > 0 ? KC_UP : KC_DOWN;
+		for (int i = 0; i < 3; ++i) {
+			async_msg_4(exch, INPUT_EVENT_KEY, KEY_PRESS, code, 0, 0);
+		}
+		async_msg_4(exch, INPUT_EVENT_KEY, KEY_RELEASE, code, 0, 0);
+	}
 	async_exchange_end(exch);
 }
@@ -397,7 +409,4 @@
 	 * them automatically.
 	 */
-#if defined(UARCH_amd64)
-	kbd_add_dev(&chardev_port, &pc_ctl);
-#endif
 #if defined(UARCH_arm32) && defined(MACHINE_gta02)
 	kbd_add_dev(&chardev_port, &stty_ctl);
@@ -411,10 +420,4 @@
 #if defined(UARCH_arm32) && defined(MACHINE_integratorcp)
 	kbd_add_dev(&pl050_port, &pc_ctl);
-#endif
-#if defined(UARCH_ia32)
-	kbd_add_dev(&chardev_port, &pc_ctl);
-#endif
-#if defined(MACHINE_i460GX)
-	kbd_add_dev(&chardev_port, &pc_ctl);
 #endif
 #if defined(MACHINE_ski)
@@ -450,13 +453,4 @@
 	 * them automatically.
 	 */
-#if defined(UARCH_amd64)
-	mouse_add_dev(&chardev_mouse_port, &ps2_proto);
-#endif
-#if defined(UARCH_ia32)
-	mouse_add_dev(&chardev_mouse_port, &ps2_proto);
-#endif
-#if defined(MACHINE_i460GX)
-	mouse_add_dev(&chardev_mouse_port, &ps2_proto);
-#endif
 #if defined(UARCH_ppc32)
 	mouse_add_dev(&adb_mouse_port, &adb_proto);
@@ -602,12 +596,20 @@
 	int rc;
 	
+	fibril_mutex_lock(&discovery_lock);
+	
 	rc = dev_check_new_kbdevs();
-	if (rc != EOK)
+	if (rc != EOK) {
+		fibril_mutex_unlock(&discovery_lock);
 		return rc;
+	}
 	
 	rc = dev_check_new_mousedevs();
-	if (rc != EOK)
+	if (rc != EOK) {
+		fibril_mutex_unlock(&discovery_lock);
 		return rc;
-
+	}
+	
+	fibril_mutex_unlock(&discovery_lock);
+	
 	return EOK;
 }
@@ -658,5 +660,6 @@
 	
 	/* Register driver */
-	int rc = loc_server_register(NAME, client_connection);
+	async_set_client_connection(client_connection);
+	int rc = loc_server_register(NAME);
 	if (rc < 0) {
 		printf("%s: Unable to register server (%d)\n", NAME, rc);
Index: uspace/srv/hid/input/include/mouse.h
===================================================================
--- uspace/srv/hid/input/include/mouse.h	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/hid/input/include/mouse.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -62,5 +62,5 @@
 
 extern void mouse_push_data(mouse_dev_t *, sysarg_t);
-extern void mouse_push_event_move(mouse_dev_t *, int, int);
+extern void mouse_push_event_move(mouse_dev_t *, int, int, int);
 extern void mouse_push_event_button(mouse_dev_t *, int, int);
 
Index: uspace/srv/hid/input/include/mouse_proto.h
===================================================================
--- uspace/srv/hid/input/include/mouse_proto.h	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/hid/input/include/mouse_proto.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -48,5 +48,4 @@
 
 extern mouse_proto_ops_t adb_proto;
-extern mouse_proto_ops_t ps2_proto;
 extern mouse_proto_ops_t mousedev_proto;
 
Index: uspace/srv/hid/input/port/chardev.c
===================================================================
--- uspace/srv/hid/input/port/chardev.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/hid/input/port/chardev.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -63,5 +63,4 @@
 /** List of devices to try connecting to. */
 static const char *in_devs[] = {
-	"char/ps2a",
 	"char/s3c24ser"
 };
Index: uspace/srv/hid/input/port/gxemul.c
===================================================================
--- uspace/srv/hid/input/port/gxemul.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/hid/input/port/gxemul.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -90,5 +90,5 @@
 	async_set_interrupt_received(gxemul_irq_handler);
 	gxemul_cmds[0].addr = (void *) addr;
-	register_irq(inr, device_assign_devno(), 0, &gxemul_kbd);
+	irq_register(inr, device_assign_devno(), 0, &gxemul_kbd);
 	return 0;
 }
Index: uspace/srv/hid/input/port/msim.c
===================================================================
--- uspace/srv/hid/input/port/msim.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/hid/input/port/msim.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -89,5 +89,5 @@
 	msim_cmds[0].addr = (void *) vaddr;
 	async_set_interrupt_received(msim_irq_handler);
-	register_irq(inr, device_assign_devno(), 0, &msim_kbd);
+	irq_register(inr, device_assign_devno(), 0, &msim_kbd);
 	
 	return 0;
Index: uspace/srv/hid/input/port/niagara.c
===================================================================
--- uspace/srv/hid/input/port/niagara.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/hid/input/port/niagara.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -63,9 +63,4 @@
 #define POLL_INTERVAL  10000
 
-/**
- * Virtual address mapped to the buffer shared with the kernel counterpart.
- */
-static uintptr_t input_buffer_addr;
-
 /*
  * Kernel counterpart of the driver pushes characters (it has read) here.
@@ -102,8 +97,6 @@
 		return -1;
 	
-	input_buffer_addr = (uintptr_t) as_get_mappable_page(PAGE_SIZE);
-	int rc = physmem_map((void *) paddr, (void *) input_buffer_addr,
-	    1, AS_AREA_READ | AS_AREA_WRITE);
-	
+	int rc = physmem_map((void *) paddr, 1,
+	    AS_AREA_READ | AS_AREA_WRITE, (void *) &input_buffer);
 	if (rc != 0) {
 		printf("Niagara: uspace driver couldn't map physical memory: %d\n",
@@ -111,6 +104,4 @@
 		return rc;
 	}
-	
-	input_buffer = (input_buffer_t) input_buffer_addr;
 	
 	thread_id_t tid;
Index: uspace/srv/hid/input/port/ns16550.c
===================================================================
--- uspace/srv/hid/input/port/ns16550.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/hid/input/port/ns16550.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -135,5 +135,5 @@
 	
 	async_set_interrupt_received(ns16550_irq_handler);
-	register_irq(inr, device_assign_devno(), inr, &ns16550_kbd);
+	irq_register(inr, device_assign_devno(), inr, &ns16550_kbd);
 	
 	return pio_enable((void *) ns16550_physical, 8, &vaddr);
Index: uspace/srv/hid/input/port/pl050.c
===================================================================
--- uspace/srv/hid/input/port/pl050.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/hid/input/port/pl050.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -117,5 +117,5 @@
 	
 	async_set_interrupt_received(pl050_irq_handler);
-	register_irq(inr, device_assign_devno(), 0, &pl050_kbd);
+	irq_register(inr, device_assign_devno(), 0, &pl050_kbd);
 	
 	return 0;
Index: uspace/srv/hid/input/proto/adb.c
===================================================================
--- uspace/srv/hid/input/proto/adb.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/hid/input/proto/adb.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -82,5 +82,5 @@
 	
 	if (dx != 0 || dy != 0)
-		mouse_push_event_move(mouse_dev, dx, dy);
+		mouse_push_event_move(mouse_dev, dx, dy, 0);
 }
 
Index: uspace/srv/hid/input/proto/mousedev.c
===================================================================
--- uspace/srv/hid/input/proto/mousedev.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/hid/input/proto/mousedev.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -91,11 +91,12 @@
 		switch (IPC_GET_IMETHOD(call)) {
 		case MOUSEEV_MOVE_EVENT:
-			mouse_push_event_move(mousedev->mouse_dev, IPC_GET_ARG1(call),
-			    IPC_GET_ARG2(call));
+			mouse_push_event_move(mousedev->mouse_dev,
+			    IPC_GET_ARG1(call), IPC_GET_ARG2(call),
+			    IPC_GET_ARG3(call));
 			retval = EOK;
 			break;
 		case MOUSEEV_BUTTON_EVENT:
-			mouse_push_event_button(mousedev->mouse_dev, IPC_GET_ARG1(call),
-			    IPC_GET_ARG2(call));
+			mouse_push_event_button(mousedev->mouse_dev,
+			    IPC_GET_ARG1(call), IPC_GET_ARG2(call));
 			retval = EOK;
 			break;
Index: uspace/srv/hid/remcons/Makefile
===================================================================
--- uspace/srv/hid/remcons/Makefile	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ uspace/srv/hid/remcons/Makefile	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,36 @@
+#
+# Copyright (c) 2012 Vojtech Horky
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../../..
+BINARY = remcons
+
+SOURCES = \
+	remcons.c \
+	user.c
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/srv/hid/remcons/remcons.c
===================================================================
--- uspace/srv/hid/remcons/remcons.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ uspace/srv/hid/remcons/remcons.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,391 @@
+/*
+ * Copyright (c) 2012 Vojtech Horky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup remcons
+ * @{
+ */
+/** @file
+ */
+
+#include <async.h>
+#include <stdio.h>
+#include <adt/prodcons.h>
+#include <ipc/input.h>
+#include <ipc/console.h>
+#include <ipc/vfs.h>
+#include <errno.h>
+#include <str_error.h>
+#include <loc.h>
+#include <event.h>
+#include <io/keycode.h>
+#include <align.h>
+#include <malloc.h>
+#include <as.h>
+#include <fibril_synch.h>
+#include <task.h>
+#include <net/in.h>
+#include <net/inet.h>
+#include <net/socket.h>
+#include <io/console.h>
+#include <inttypes.h>
+#include "telnet.h"
+#include "user.h"
+
+#define APP_GETTERM  "/app/getterm"
+#define APP_SHELL "/app/bdsh"
+
+/** Telnet commands to force character mode
+ * (redundant to be on the safe side).
+ * See
+ * http://stackoverflow.com/questions/273261/force-telnet-user-into-character-mode
+ * for discussion.
+ */
+static const telnet_cmd_t telnet_force_character_mode_command[] = {
+	TELNET_IAC, TELNET_WILL, TELNET_ECHO,
+	TELNET_IAC, TELNET_WILL, TELNET_SUPPRESS_GO_AHEAD,
+	TELNET_IAC, TELNET_WONT, TELNET_LINEMODE
+};
+static const size_t telnet_force_character_mode_command_count =
+    sizeof(telnet_force_character_mode_command) / sizeof(telnet_cmd_t);
+
+
+/** Handling client requests (VFS and console interface).
+ *
+ * @param user Telnet user the requests belong to.
+ */
+static void client_connection_message_loop(telnet_user_t *user)
+{
+	while (true) {
+		ipc_call_t call;
+		ipc_callid_t callid = 0;
+
+		/*
+		 * The getterm task might terminate while we are here,
+		 * waiting for a call. Also, the socket might be closed
+		 * meanwhile.
+		 * We want to detect this situation early, so we use a
+		 * timeout variant of async_get_call().
+		 */
+		while (callid == 0) {
+			callid = async_get_call_timeout(&call, 1000);
+
+			if (telnet_user_is_zombie(user)) {
+				if (callid != 0) {
+					async_answer_0(callid, EINTR);
+				}
+				return;
+			}
+		}
+		
+		if (!IPC_GET_IMETHOD(call)) {
+			return;
+		}
+
+		switch (IPC_GET_IMETHOD(call)) {
+		case CONSOLE_GET_SIZE:
+			async_answer_2(callid, EOK, 100, 1);
+			break;
+		case CONSOLE_GET_POS:
+			fibril_mutex_lock(&user->guard);
+			async_answer_2(callid, EOK, user->cursor_x, 0);
+			fibril_mutex_unlock(&user->guard);
+			break;
+		case CONSOLE_GET_EVENT: {
+			kbd_event_t event;
+			int rc = telnet_user_get_next_keyboard_event(user, &event);
+			if (rc != EOK) {
+				/* Silently ignore. */
+				async_answer_0(callid, EOK);
+				break;
+			}
+			async_answer_4(callid, EOK, event.type, event.key, event.mods, event.c);
+			break;
+		}
+		case CONSOLE_GOTO: {
+			int new_x = IPC_GET_ARG1(call);
+			telnet_user_update_cursor_x(user, new_x);
+			async_answer_0(callid, ENOTSUP);
+			break;
+		}
+		case VFS_OUT_READ:
+			async_answer_0(callid, ENOTSUP);
+			break;
+		case VFS_OUT_WRITE: {
+			uint8_t *buf;
+			size_t size;
+			int rc = async_data_write_accept((void **)&buf, false, 0, 0, 0, &size);
+
+			if (rc != EOK) {
+				async_answer_0(callid, rc);
+				break;
+			}
+
+			rc = telnet_user_send_data(user, buf, size);
+			free(buf);
+
+			if (rc != EOK) {
+				async_answer_0(callid, rc);
+				break;
+			}
+
+			async_answer_1(callid, EOK, size);
+			break;
+		}
+		case VFS_OUT_SYNC:
+			async_answer_0(callid, EOK);
+			break;
+		case CONSOLE_CLEAR:
+			async_answer_0(callid, EOK);
+			break;
+
+		case CONSOLE_GET_COLOR_CAP:
+			async_answer_1(callid, EOK, CONSOLE_CAP_NONE);
+			break;
+		case CONSOLE_SET_STYLE:
+			async_answer_0(callid, ENOTSUP);
+			break;
+		case CONSOLE_SET_COLOR:
+			async_answer_0(callid, ENOTSUP);
+			break;
+		case CONSOLE_SET_RGB_COLOR:
+			async_answer_0(callid, ENOTSUP);
+			break;
+
+		case CONSOLE_CURSOR_VISIBILITY:
+			async_answer_0(callid, ENOTSUP);
+			break;
+
+		default:
+			async_answer_0(callid, EINVAL);
+			break;
+		}
+	}
+}
+
+/** Callback when client connects to a telnet terminal. */
+static void client_connection(ipc_callid_t iid, ipc_call_t *icall, void *arg)
+{
+	/* Find the user. */
+	telnet_user_t *user = telnet_user_get_for_client_connection(IPC_GET_ARG1(*icall));
+	if (user == NULL) {
+		async_answer_0(iid, ENOENT);
+		return;
+	}
+	async_answer_0(iid, EOK);
+
+	telnet_user_log(user, "New client connected (%" PRIxn").", iid);
+
+	/* Force character mode. */
+	send(user->socket, (void *)telnet_force_character_mode_command,
+	    telnet_force_character_mode_command_count, 0);
+
+	/* Handle messages. */
+	client_connection_message_loop(user);
+
+	telnet_user_notify_client_disconnected(user);
+	telnet_user_log(user, "Client disconnected (%" PRIxn").", iid);
+}
+
+/** Fibril for spawning the task running after user connects.
+ *
+ * @param arg Corresponding @c telnet_user_t structure.
+ */
+static int spawn_task_fibril(void *arg)
+{
+	telnet_user_t *user = arg;
+	int rc;
+
+	char term[LOC_NAME_MAXLEN];
+	snprintf(term, LOC_NAME_MAXLEN, "%s/%s", "/loc", user->service_name);
+
+	task_id_t task;
+	rc = task_spawnl(&task, APP_GETTERM, APP_GETTERM, "-w", term, APP_SHELL, NULL);
+	if (rc != EOK) {
+		telnet_user_error(user, "Spawning `%s -w %s %s' failed: %s.",
+		    APP_GETTERM, term, APP_SHELL, str_error(rc));
+		fibril_mutex_lock(&user->guard);
+		user->task_finished = true;
+		fibril_condvar_signal(&user->refcount_cv);
+		fibril_mutex_unlock(&user->guard);
+		return EOK;
+	}
+
+	fibril_mutex_lock(&user->guard);
+	user->task_id = task;
+	fibril_mutex_unlock(&user->guard);
+
+	task_exit_t task_exit;
+	int task_retval;
+	task_wait(task, &task_exit, &task_retval);
+	telnet_user_log(user, "%s terminated %s, exit code %d.", APP_GETTERM,
+	    task_exit == TASK_EXIT_NORMAL ? "normally" : "unexpectedly",
+	    task_retval);
+
+	/* Announce destruction. */
+	fibril_mutex_lock(&user->guard);
+	user->task_finished = true;
+	fibril_condvar_signal(&user->refcount_cv);
+	fibril_mutex_unlock(&user->guard);
+
+	return EOK;
+}
+
+/** Tell whether given user can be destroyed (has no active clients).
+ *
+ * @param user The telnet user in question.
+ */
+static bool user_can_be_destroyed_no_lock(telnet_user_t *user)
+{
+	return user->task_finished && user->socket_closed &&
+	    (user->locsrv_connection_count == 0);
+}
+
+/** Fibril for each accepted socket.
+ *
+ * @param arg Corresponding @c telnet_user_t structure.
+ */
+static int network_user_fibril(void *arg)
+{
+	int rc;
+	telnet_user_t *user = arg;
+
+	rc = loc_service_register(user->service_name, &user->service_id);
+	if (rc != EOK) {
+		telnet_user_error(user, "Unable to register %s with loc: %s.",
+		    user->service_name, str_error(rc));
+		return EOK;
+	}
+
+	telnet_user_log(user, "Service %s registerd with id %" PRIun ".",
+	    user->service_name, user->service_id);
+
+	fid_t spawn_fibril = fibril_create(spawn_task_fibril, user);
+	assert(spawn_fibril);
+	fibril_add_ready(spawn_fibril);
+
+	/* Wait for all clients to exit. */
+	fibril_mutex_lock(&user->guard);
+	while (!user_can_be_destroyed_no_lock(user)) {
+		if (user->task_finished) {
+			closesocket(user->socket);
+			user->socket_closed = true;
+			continue;
+		} else if (user->socket_closed) {
+			if (user->task_id != 0) {
+				task_kill(user->task_id);
+			}
+		}
+		fibril_condvar_wait_timeout(&user->refcount_cv, &user->guard, 1000);
+	}
+	fibril_mutex_unlock(&user->guard);
+
+	rc = loc_service_unregister(user->service_id);
+	if (rc != EOK) {
+		telnet_user_error(user,
+		    "Unable to unregister %s from loc: %s (ignored).",
+		    user->service_name, str_error(rc));
+	}
+
+	telnet_user_log(user, "Destroying...");
+	telnet_user_destroy(user);
+
+	return EOK;
+}
+
+int main(int argc, char *argv[])
+{
+	int port = 2223;
+	
+	async_set_client_connection(client_connection);
+	int rc = loc_server_register(NAME);
+	if (rc < 0) {
+		fprintf(stderr, NAME ": Unable to register server: %s.\n",
+		    str_error(rc));
+		return 1;
+	}
+
+	struct sockaddr_in addr;
+
+	addr.sin_family = AF_INET;
+	addr.sin_port = htons(port);
+
+	rc = inet_pton(AF_INET, "127.0.0.1", (void *)
+	    &addr.sin_addr.s_addr);
+	if (rc != EOK) {
+		fprintf(stderr, "Error parsing network address: %s.\n",
+		    str_error(rc));
+		return 2;
+	}
+
+	int listen_sd = socket(PF_INET, SOCK_STREAM, 0);
+	if (listen_sd < 0) {
+		fprintf(stderr, "Error creating listening socket: %s.\n",
+		    str_error(listen_sd));
+		return 3;
+	}
+
+	rc = bind(listen_sd, (struct sockaddr *) &addr, sizeof(addr));
+	if (rc != EOK) {
+		fprintf(stderr, "Error binding socket: %s.\n",
+		    str_error(rc));
+		return 4;
+	}
+
+	rc = listen(listen_sd, BACKLOG_SIZE);
+	if (rc != EOK) {
+		fprintf(stderr, "listen() failed: %s.\n", str_error(rc));
+		return 5;
+	}
+
+	printf("%s: HelenOS Remote console service\n", NAME);
+
+	while (true) {
+		struct sockaddr_in raddr;
+		socklen_t raddr_len = sizeof(raddr);
+		int conn_sd = accept(listen_sd, (struct sockaddr *) &raddr,
+		    &raddr_len);
+
+		if (conn_sd < 0) {
+			fprintf(stderr, "accept() failed: %s.\n",
+			    str_error(rc));
+			continue;
+		}
+
+		telnet_user_t *user = telnet_user_create(conn_sd);
+		assert(user);
+
+		fid_t fid = fibril_create(network_user_fibril, user);
+		assert(fid);
+		fibril_add_ready(fid);
+	}
+
+	return 0;
+}
+
+/** @}
+ */
Index: uspace/srv/hid/remcons/remcons.h
===================================================================
--- uspace/srv/hid/remcons/remcons.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ uspace/srv/hid/remcons/remcons.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2012 Vojtech Horky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup remcons
+ * @{
+ */
+/** @file
+ */
+
+#ifndef REMCONS_H_
+#define REMCONS_H_
+
+#define NAME       "remcons"
+#define NAMESPACE  "term"
+#define BACKLOG_SIZE  5
+
+#endif
+
+/**
+ * @}
+ */
Index: uspace/srv/hid/remcons/telnet.h
===================================================================
--- uspace/srv/hid/remcons/telnet.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ uspace/srv/hid/remcons/telnet.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,64 @@
+/*
+ * Copyright (c) 2012 Vojtech Horky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup remcons
+ * @{
+ */
+/** @file
+ */
+
+#ifndef TELNET_H_
+#define TELNET_H_
+
+#include <inttypes.h>
+
+typedef uint8_t telnet_cmd_t;
+
+/*
+ * Telnet commands.
+ */
+
+#define TELNET_IAC 255
+
+#define TELNET_WILL 251
+#define TELNET_WONT 252
+#define TELNET_DO 253
+#define TELNET_DONT 254
+
+#define TELNET_IS_OPTION_CODE(code) (((code) >= 251) && ((code) <= 254))
+
+#define TELNET_ECHO 1
+#define TELNET_SUPPRESS_GO_AHEAD 3
+#define TELNET_LINEMODE 34
+
+
+#endif
+
+/**
+ * @}
+ */
